<?php

/**
 * Copyright (c) BoonEx Pty Limited - http://www.boonex.com/
 * CC-BY License - http://creativecommons.org/licenses/by/3.0/
 */

bx_import('Module', $aModule);
bx_import('BxTemplProfileView');
bx_import('BxTemplConfig');

class BxWall2Page extends BxTemplProfileView
{
    var $_sOwner;
    var $_oWall2;

    function BxWall2Page($sOwner, &$oWall2)
    {
        $this->_sOwner = $sOwner;
        $this->_oWall2 = &$oWall2;

        $this->oProfileGen = new BxBaseProfileGenerator(getId($sOwner, 0));
        $this->aConfSite = $GLOBALS['site'];
        $this->aConfDir  = $GLOBALS['dir'];
        parent::BxDolPageView('wall2');
    }
    function getBlockCode_Post()
    {
        if(!empty($this->_sOwner))
            return $this->_oWall2->servicePostBlock($this->_sOwner, 'username');
        else if(isLogged())
            return $this->_oWall2->servicePostBlock(getLoggedId());
        else
            return MsgBox(_t('_wall2_msg_no_results'));
    }
    function getBlockCode_View()
    {
        if(!empty($this->_sOwner))
            return $this->_oWall2->serviceViewBlock($this->_sOwner, -1, -1, '', '', 'username');
        else if(isLogged())
            return $this->_oWall2->serviceViewBlock(getLoggedId());
        else
            return MsgBox(_t('_wall2_msg_no_results'));
    }
    function getCode()
    {
        if(!empty($this->_sOwner)) {
            $aOwner = $this->_oWall2->_oDb->getUser($this->_sOwner, 'username');
            if((int)$aOwner['id'] == 0)
                return MsgBox(_t('_wall2_msg_page_not_found'));
        }

        return parent::getCode();
    }
}

global $_page;
global $_page_cont;

$iIndex = 1;
$_page['name_index'] = $iIndex;
$_page['css_name'] = 'cmts.css';
$_page['js_name'] = 'BxDolCmts.js';
$_page['header'] = _t('_wall2_page_caption');

$oSubscription = new BxDolSubscription();
$oWall2 = new BxWall2Module($aModule);
$sOwnerUsername = isset($aRequest[0]) ? process_db_input($aRequest[0], BX_TAGS_STRIP) : '';
$oWall2Page = new BxWall2Page($sOwnerUsername, $oWall2);
$_page_cont[$iIndex]['page_main_code'] = $oSubscription->getData() . $oWall2Page->getCode();

$oWall2->_oTemplate->setPageTitle((!empty($sOwnerUsername) ? _t('_wall2_page_caption', ucfirst($sOwnerUsername)) : _t('_wall2_page_caption_my')) );
PageCode($oWall2->_oTemplate);
