--
-- Table structure for table `[db_prefix]events`
--
CREATE TABLE IF NOT EXISTS `[db_prefix]events` (
  `id` bigint(8) NOT NULL auto_increment,
  `owner_id` int(10) unsigned NOT NULL default '0',
  `object_id` text collate utf8_unicode_ci NOT NULL,
  `type` varchar(255) collate utf8_unicode_ci NOT NULL,
  `action` varchar(255) collate utf8_unicode_ci NOT NULL,
  `content` text collate utf8_unicode_ci NOT NULL,
  `title` varchar(255) collate utf8_unicode_ci NOT NULL,
  `description` text collate utf8_unicode_ci NOT NULL,
  `date` int(8) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `owner_id` (`owner_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Table structure for table `[db_prefix]comments`
--
CREATE TABLE IF NOT EXISTS `[db_prefix]comments` (
  `cmt_id` int(11) NOT NULL auto_increment,
  `cmt_parent_id` int(11) NOT NULL default '0',
  `cmt_object_id` int(11) NOT NULL default '0',
  `cmt_author_id` int(10) unsigned NOT NULL default '0',
  `cmt_text` text NOT NULL,
  `cmt_mood` tinyint(4) NOT NULL default '0',
  `cmt_rate` int(11) NOT NULL default '0',
  `cmt_rate_count` int(11) NOT NULL default '0',
  `cmt_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `cmt_replies` int(11) NOT NULL default '0',
  PRIMARY KEY  (`cmt_id`),
  KEY `cmt_object_id` (`cmt_object_id`,`cmt_parent_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Table structure for table `[db_prefix]comments_track`
--
CREATE TABLE IF NOT EXISTS `[db_prefix]comments_track` (
  `cmt_system_id` int(11) NOT NULL default '0',
  `cmt_id` int(11) NOT NULL default '0',
  `cmt_rate` tinyint(4) NOT NULL default '0',
  `cmt_rate_author_id` int(10) unsigned NOT NULL default '0',
  `cmt_rate_author_nip` int(11) unsigned NOT NULL default '0',
  `cmt_rate_ts` int(11) NOT NULL default '0',
  PRIMARY KEY  (`cmt_system_id`,`cmt_id`,`cmt_rate_author_nip`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Table structure for table `[db_prefix]handlers`
--
CREATE TABLE IF NOT EXISTS `[db_prefix]handlers` (
  `id` int(11) NOT NULL auto_increment,
  `alert_unit` varchar(64) NOT NULL default '',
  `alert_action` varchar(64) NOT NULL default '',
  `module_uri` varchar(64) NOT NULL default '',
  `module_class` varchar(64) NOT NULL default '',
  `module_method` varchar(64) NOT NULL default '',
  `groupable` tinyint(1) NOT NULL default '0',
  `group_by` varchar(64) NOT NULL default '',
  `timeline2` tinyint(1) NOT NULL default '1',
  `outline2` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE `handler` (`alert_unit`, `alert_action`, `module_uri`, `module_class`, `module_method`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO `[db_prefix]handlers`(`alert_unit`, `alert_action`, `module_uri`, `module_class`, `module_method`, `groupable`, `group_by`, `timeline2`, `outline2`) VALUES
('wall2_common_text', '', '', '', '', 0, '', 1, 0),
('wall2_common_link', '', '', '', '', 0, '', 1, 0),
('wall2_common_photos', '', '', '', '', 0, '', 1, 0),
('wall2_common_sounds', '', '', '', '', 0, '', 1, 0),
('wall2_common_videos', '', '', '', '', 0, '', 1, 0),
('profile', 'edit', '', '', '', 0, '', 1, 0),
('profile', 'edit_status_message', '', '', '', 0, '', 1, 0),
('profile', 'commentPost', '', '', '', 0, '', 1, 0),
('profile', 'delete', '', '', '', 0, '', 1, 0),
('friend', 'accept', '', '', '', 0, '', 1, 0);


SELECT @iPCPOrder:=MAX(`Order`) FROM `sys_page_compose_pages`;
INSERT INTO `sys_page_compose_pages`(`Name`, `Title`, `Order`) VALUES ('wall2', 'Wall2', @iPCPOrder+1);

SELECT @iPCOrderIndex:=MAX(`Order`) FROM `sys_page_compose` WHERE `Page`='index' AND `Column`='1';
SELECT @iPCOrderProfile:=MAX(`Order`) FROM `sys_page_compose` WHERE `Page`='profile' AND `Column`='2';
SELECT @iPCOrderMember:=MAX(`Order`) FROM `sys_page_compose` WHERE `Page`='member' AND `Column`='1';
INSERT INTO `sys_page_compose` (`Page`, `PageWidth`, `Desc`, `Caption`, `Column`, `Order`, `Func`, `Content`, `DesignBox`, `ColWidth`, `Visible`, `MinWidth`) VALUES
('index', '1140px', 'Events Outline2', '_wall2_pc_view_index', 1, @iPCOrderIndex+1, 'PHP', 'return BxDolService::call(\'wall2\', \'view_block_index\');', 1, 71.9, 'non,memb', 0),
('profile', '1140px', 'Post event to a Timeline2', '_wall2_pc_post', 2, @iPCOrderProfile+1, 'PHP', 'return BxDolService::call(\'wall2\', \'post_block\', array($this->oProfileGen->_iProfileID));', 1, 71.9, 'non,memb', 0),
('profile', '1140px', 'View events on a Timeline2', '_wall2_pc_view', 2, @iPCOrderProfile+2, 'PHP', 'return BxDolService::call(\'wall2\', \'view_block\', array($this->oProfileGen->_iProfileID));', 1, 71.9, 'non,memb', 0),
('member', '1140px', 'View events on a Timeline2', '_wall2_pc_view_account', 1, @iPCOrderMember+1, 'PHP', 'return BxDolService::call(\'wall2\', \'view_block_account\', array($this->iMember));', 1, 71.9, 'memb', 0),
('wall2', '1140px', 'Post event to a Timeline2', '_wall2_pc_post', 1, 0, 'Post', '', 1, 100, 'non,memb', 0),
('wall2', '1140px', 'View events on a Timeline2', '_wall2_pc_view', 1, 1, 'View', '', 1, 100, 'non,memb', 0);


SELECT @iTMOrderOwner:=MAX(`Order`) FROM `sys_menu_top` WHERE `Parent`='4';
SELECT @iTMOrderViewer:=MAX(`Order`) FROM `sys_menu_top` WHERE `Parent`='9';
INSERT INTO `sys_menu_top` (`Parent`, `Name`, `Caption`, `Link`, `Order`, `Visible`, `Target`, `Onclick`, `Check`, `Editable`, `Deletable`, `Active`, `Type`, `Picture`, `BQuickLink`, `Statistics`) VALUES
(4, 'Timeline2Owner', '_wall2_top_smenu_item_my_wall2', 'modules/?r=wall2/', @iTMOrderOwner+1, 'memb', '', '', '', 1, 1, 1, 'custom', '', 0, ''),
(9, 'Timeline2Viewer', '_wall2_top_smenu_item_wall2', 'modules/?r=wall2/index/{profileUsername}', @iTMOrderViewer+1, 'non,memb', '', '', '', 1, 1, 1, 'custom', '', 0, '');


SET @iOrder = (SELECT MAX(`order`) FROM `sys_menu_admin` WHERE `parent_id`='2');
INSERT INTO `sys_menu_admin`(`parent_id`, `name`, `title`, `url`, `description`, `icon`, `icon_large`, `check`, `order`) VALUES
(2, 'bx_wall2', '_wall2_admin_menu_sitem', '{siteUrl}modules/?r=wall2/admin/', 'For managing Timeline2', 'time', '', '', @iOrder+1);


INSERT INTO `sys_objects_cmts` (`ObjectName`, `TableCmts`, `TableTrack`, `AllowTags`, `Nl2br`, `SecToEdit`, `PerView`, `IsRatable`, `ViewingThreshold`, `AnimationEffect`, `AnimationSpeed`, `IsOn`, `IsMood`, `RootStylePrefix`, `TriggerTable`, `TriggerFieldId`, `TriggerFieldComments`, `ClassName`, `ClassFile`)
VALUES('bx_wall2', '[db_prefix]comments', '[db_prefix]comments_track', 0, 1, 90, 9999, 1, -3, 'none', 0, 1, 0, 'wcmt', '', '', '', 'BxWall2Cmts', 'modules/boonex/wall2/classes/BxWall2Cmts.php');



SET @iCategoryOrder = (SELECT MAX(`menu_order`) FROM `sys_options_cats`) + 1;
INSERT INTO `sys_options_cats` (`name` , `menu_order` ) VALUES ('Timeline2', @iCategoryOrder);
SET @iCategoryId = LAST_INSERT_ID();

INSERT INTO `sys_options` (`Name`, `VALUE`, `kateg`, `desc`, `Type`, `check`, `err_text`, `order_in_kateg`, `AvailableValues`) VALUES
('permalinks_module_wall2', 'on', 26, 'Enable friendly Timeline2 permalink', 'checkbox', '', '', 0, ''),
('wall2_enable_guest_comments', '', @iCategoryId, 'Allow non-members to post in Timeline2', 'checkbox', '', '', 1, ''),
('wall2_enable_delete', 'on', @iCategoryId, 'Allow Timeline2 owner to remove events', 'checkbox', '', '', 2, ''),
('wall2_events_per_page_profile', '10', @iCategoryId, 'Number of events are displayed on Profile page', 'digit', '', '', 3, ''),
('wall2_events_per_page_account', '20', @iCategoryId, 'Number of events are displayed on Account page', 'digit', '', '', 4, ''),
('wall2_events_per_page_index', '20', @iCategoryId, 'Number of events are displayed on Home page', 'digit', '', '', 5, ''),
('wall2_rss_length', '5', @iCategoryId, 'The length of RSS feed', 'digit', '', '', 6, ''),
('wall2_events_hide_timeline2', '', @iCategoryId, 'Hide events from Timeline2', 'select_multiple', '', '', 7, 'PHP:return BxDolService::call(\'wall2\', \'get_actions_checklist\', array(\'timeline2\'));'),
('wall2_events_hide_outline2', '', @iCategoryId, 'Hide events from Outline2', 'select_multiple', '', '', 7, 'PHP:return BxDolService::call(\'wall2\', \'get_actions_checklist\', array(\'outline2\'));');


SET @iLevelNonMember := 1;
SET @iLevelStandard := 2;
SET @iLevelPromotion := 3;

INSERT INTO `sys_acl_actions`(`Name`, `AdditionalParamName`) VALUES ('timeline2 post comment', '');
SET @iAction := LAST_INSERT_ID();
INSERT INTO `sys_acl_matrix` (`IDLevel`, `IDAction`) VALUES 
(@iLevelStandard, @iAction), 
(@iLevelPromotion, @iAction);

INSERT INTO `sys_acl_actions`(`Name`, `AdditionalParamName`) VALUES ('timeline2 delete comment', '');


INSERT INTO `sys_categories`(`Category`, `ID`, `Type`, `Owner`, `Status`) VALUES
('wall2', 0, 'bx_photos', 0, 'active'),
('wall2', 0, 'bx_sounds', 0, 'active'),
('wall2', 0, 'bx_videos', 0, 'active');


INSERT INTO `sys_permalinks`(`standard`, `permalink`, `check`) VALUES('modules/?r=wall2/', 'm/wall2/', 'permalinks_module_wall2');


INSERT INTO `sys_alerts_handlers`(`name`, `class`, `file`, `eval`) VALUES ('bx_wall2', '', '', 'BxDolService::call(\'wall2\', \'response\', array($this));');
SET @iHandlerId = LAST_INSERT_ID();

INSERT INTO `sys_alerts` (`unit`, `action`, `handler_id`) VALUES
('profile', 'edit', @iHandlerId),
('profile', 'edit_status_message', @iHandlerId),
('profile', 'commentPost', @iHandlerId),
('profile', 'delete', @iHandlerId),
('friend', 'accept', @iHandlerId);

INSERT INTO `sys_sbs_types`(`unit`, `action`, `template`, `params`) VALUES
('bx_wall2', '', '', 'return BxDolService::call(\'wall2\', \'get_subscription_params\', array($arg1, $arg2, $arg3));'),
('bx_wall2', 'update', 't_sbsWall2Updates', 'return BxDolService::call(\'wall2\', \'get_subscription_params\', array($arg1, $arg2, $arg3));');

INSERT INTO `sys_email_templates`(`Name`, `Subject`, `Body`, `Desc`, `LangID`) VALUES
('t_sbsWall2Updates', 'Subscription: New Timeline2 Event', '<bx_include_auto:_email_header.html />\r\n\r\n<p><b>Dear <RealName></b>,</p>\r\n\r\n<p>\r\nThere was a new update of the Timeline2 you subsribed to!\r\n</p>\r\n\r\n<p>\r\n<a href="<ViewLink>">View it now</a>\r\n</p>\r\n\r\n<bx_include_auto:_email_footer.html />', 'Subscription: New Timeline2 Event', 0);

-- chart
SET @iMaxOrderCharts = (SELECT MAX(`order`)+1 FROM `sys_objects_charts`);
INSERT INTO `sys_objects_charts` (`object`, `title`, `table`, `field_date_ts`, `field_date_dt`, `query`, `active`, `order`) VALUES
('bx_wall2', '_bx_wall2_chart', 'bx_wall2_events', 'date', '', '', 1, @iMaxOrderCharts);


