function BxWall2Outline2(oOptions) {
    this._sActionsUrl = oOptions.sActionUrl;
    this._sObjName = oOptions.sObjName == undefined ? 'oWall2Outline2' : oOptions.sObjName;
    this._iOwnerId = oOptions.iOwnerId == undefined ? 0 : oOptions.iOwnerId;
    this._sAnimationEffect = oOptions.sAnimationEffect == undefined ? 'slide' : oOptions.sAnimationEffect;
    this._iAnimationSpeed = oOptions.iAnimationSpeed == undefined ? 'slow' : oOptions.iAnimationSpeed;

    $(document).ready(function() {
    	$('#bx-wall2-outline2 .wall2-outline2-items').masonry({
		  itemSelector: '.wall2-oi-item',
		  columnWidth: 170,
		  gutterWidth: 20
		});
    });
}

BxWall2Outline2.prototype.changePage = function(iStart, iPerPage, sFilter) {
    this.getPosts('page', iStart, iPerPage, sFilter);
};

BxWall2Outline2.prototype.getPosts = function(sAction, iStart, iPerPage, sFilter) {
    var $this = this;
    var oData = this._getDefaultData();
    var oLoading = null;

    if(iStart)
        oData['Wall2Start'] = iStart;
    if(iPerPage)
        oData['Wall2PerPage'] = iPerPage;
    if(sFilter)
        oData['Wall2Filter'] = sFilter;

    switch(sAction) {
		case 'page':
			oLoading = $('#wall2-load-more .bx-btn');
			oLoading.bx_btn_loading();
			break;

		default:
			oLoading = $('#bx-wall2-view-loading');
			oLoading.bx_loading();
			break;
    }

    jQuery.post(
        this._sActionsUrl + 'get_posts_outline2/',
        oData,
        function(oData) {
        	switch(sAction) {
        		case 'page':
        			if(oLoading)
                		oLoading.bx_btn_loading();

        			var oItems = $(oData.items);
		            $('#bx-wall2-outline2 .wall2-outline2-items').append(oItems).masonry('appended', oItems);
		            $('#bx-wall2-outline2 .wall2-load-more').replaceWith(oData.paginate);
        			break;

        		default:
        			if(oLoading)
                		oLoading.bx_loading();
        			break;
        	}
        },
        'json'
    );
};

BxWall2Outline2.prototype._getDefaultData = function () {
	var oDate = new Date();
    return {_t: oDate.getTime()};
};