function BxWall2View(oOptions) {
    this._sActionsUrl = oOptions.sActionUrl;
    this._sObjName = oOptions.sObjName == undefined ? 'oWall2View' : oOptions.sObjName;
    this._iOwnerId = oOptions.iOwnerId == undefined ? 0 : oOptions.iOwnerId;
    this._iGlobAllowHtml = 0;
    this._sAnimationEffect = oOptions.sAnimationEffect == undefined ? 'slide' : oOptions.sAnimationEffect;
    this._iAnimationSpeed = oOptions.iAnimationSpeed == undefined ? 'slow' : oOptions.iAnimationSpeed;
}

BxWall2View.prototype.deletePost = function(iId) {
    var $this = this;
    var oData = this._getDefaultData();
    var oLoading = $('#bx-wall2-view-loading');

    oData['Wall2EventId'] = iId;

    if(oLoading)
    	oLoading.bx_loading();

    $.post(
        this._sActionsUrl + 'delete/',
        oData,
        function(oData) {
        	if(oLoading)
        		oLoading.bx_loading();

            if(oData.code == 0)
                $('#wall2-event-' + oData.id + ', #wall2-event-' + oData.id + ' + .wall2-divider-nerrow').bxwall2anim('hide', $this._sAnimationEffect, $this._iAnimationSpeed, function() {
                    $(this).remove();
                    
                    if($('#bxwall2 .wall2-view :last').is('.wall2-divider-nerrow'))
                    	$('#bxwall2 .wall2-view :last').remove();

                    if($('#bxwall2 .wall2-view .wall2-events .wall2-event').length == 0) {
                    	$('.wall2-view .wall2-events div.wall2-divider-today').hide();
                    	$('.wall2-view .wall2-events div.wall2-load-more').hide();
                    	$('.wall2-view .wall2-events div.wall2-empty').show();
                    }
                });                        
        },
        'json'
    );
};

BxWall2View.prototype.changeFilter = function(oLink) {
    var sId = $(oLink).attr('id');
    var sFilter = sId.substr(sId.lastIndexOf('-') + 1, sId.length);

    //--- Change Control ---//
    $(oLink).parent().siblings('.active:visible').hide().siblings('.notActive:hidden').show().siblings('#' + sId + '-pas:visible').hide().siblings('#' + sId + '-act:hidden').show();

    this.getTimeline2(0, null, sFilter, null);
    this.getPosts('filter', 0, null, sFilter, null);

    //--- Is used with common Pagination
    //this.getPaginate(0, null, sFilter);
};

BxWall2View.prototype.changeTimeline2 = function(sFilter, oEvent) {
	var sTimeline2 = $(oEvent.target).siblings("[name='timeline2']").val();

	this.getPosts('timeline2', 0, null, sFilter, sTimeline2);
};

BxWall2View.prototype.changePage = function(iStart, iPerPage, sFilter, sTimeline2) {
    this.getPosts('page', iStart, iPerPage, sFilter, sTimeline2);

    //--- Is used with common Pagination
    //this.getPaginate(iStart, iPerPage, sFilter);
};

BxWall2View.prototype.getPosts = function(sAction, iStart, iPerPage, sFilter, sTimeline2) {
    var $this = this;
    var oData = this._getDefaultData();

    if(iStart)
        oData['Wall2Start'] = iStart;
    if(iPerPage)
        oData['Wall2PerPage'] = iPerPage;
    if(sFilter)
        oData['Wall2Filter'] = sFilter;
    if(sTimeline2)
        oData['Wall2Timeline2'] = sTimeline2;

	switch(sAction) {
		case 'page':
			oLoading = $('#wall2-load-more .bx-btn');
			oLoading.bx_btn_loading();
			break;
	
		default:
			oLoading = $('#bx-wall2-view-loading');
			oLoading.bx_loading();
			break;
	}

    jQuery.post(
        this._sActionsUrl + 'get_posts/',
        oData,
        function(sResult) {
            if(sAction == 'page') {
            	if(oLoading)
            		oLoading.bx_btn_loading();

	            $('#bxwall2 .wall2-view .wall2-load-more').bxwall2anim('hide', $this._sAnimationEffect, $this._iAnimationSpeed, function() {
	                $(this).replaceWith(sResult).bxwall2anim('show', $this._sAnimationEffect, $this._iAnimationSpeed);
	            });
            }
            else {
            	if(oLoading)
            		oLoading.bx_loading();

            	$('#bxwall2 .wall2-view .wall2-events').bxwall2anim('hide', $this._sAnimationEffect, $this._iAnimationSpeed, function() {
	                $(this).html(sResult).bxwall2anim('show', $this._sAnimationEffect, $this._iAnimationSpeed);
	            });
            }
        }
    );
};

BxWall2View.prototype.getTimeline2 = function(iStart, iPerPage, sFilter, sTimeline2) {
    var $this = this;
    var oData = this._getDefaultData();
    var oLoading = $('#bx-wall2-view-loading');

    if(iStart != undefined)
        oData['Wall2Start'] = iStart;
    if(iPerPage != undefined)
        oData['Wall2PerPage'] = iPerPage;
    if(sFilter)
        oData['Wall2Filter'] = sFilter;
    if(sTimeline2)
        oData['Wall2Timeline2'] = sTimeline2;

    if(oLoading)
    	oLoading.bx_loading();

    jQuery.post (
        this._sActionsUrl + 'get_timeline2/',
        oData,
        function(sResult) {                                    
        	if(oLoading)
        		oLoading.bx_loading();

            $('#bxwall2 .wall2-view .wall2-timeline2').bxdolcmtanim('hide', $this._sAnimationEffect, $this._iAnimationSpeed, function() {
            	$(this).html(sResult);
            	$(document).addNonWebForms();
            	$(this).bxdolcmtanim('show', $this._sAnimationEffect, $this._iAnimationSpeed);
            });            
        }
    );
};

BxWall2View.prototype.getPaginate = function(iStart, iPerPage, sFilter, sTimeline2) {
    var $this = this;
    var oData = this._getDefaultData();
    var oLoading = $('#bx-wall2-view-loading');

    if(iStart != undefined)
        oData['Wall2Start'] = iStart;
    if(iPerPage != undefined)
        oData['Wall2PerPage'] = iPerPage;
    if(sFilter)
        oData['Wall2Filter'] = sFilter;
    if(sTimeline2)
        oData['Wall2Timeline2'] = sTimeline2;

    if(oLoading)
    	oLoading.bx_loading();

    jQuery.post (
        this._sActionsUrl + 'get_paginate/',
        oData,
        function(sResult) {                                    
        	if(oLoading)
        		oLoading.bx_loading();

            $('#bxwall2 > .paginate').bxdolcmtanim('hide', $this._sAnimationEffect, $this._iAnimationSpeed, function() {
                if(sResult.length > 0) {
                    $(this).replaceWith(sResult);
                    $(this).bxdolcmtanim('show', $this._sAnimationEffect, $this._iAnimationSpeed);
                }
            });            
        }
    );
};

BxWall2View.prototype._getDefaultData = function () {
	var oDate = new Date();
    return {Wall2OwnerId: this._iOwnerId, _t: oDate.getTime()};
};

BxWall2View.prototype._err = function (oElement, bShow, sMessage) {    
	if (bShow && !$(oElement).next('.wall2-post-err').length)
        $(oElement).after(' <b class="wall2-post-err">' + sMessage + '</b>');
    else if (!bShow && $(oElement).next('.wall2-post-err').length)
        $(oElement).next('.wall2-post-err').remove();    
};